
// Nyan Cat for Sharp. Sorry.

#include <mzlib.h>
#include <interrupt.h>
#include "ArkosTrackerPlayer_MZ.h"

extern char anim[];

volatile unsigned char kount=0;
volatile unsigned char musa_tick=0; // 0..17
volatile unsigned char musa_beat=0; // 0..3
volatile unsigned char musa_bar=0; // 0..255

void my_isr(void) interrupt __naked
{
    _asm

    
    push    af
    push    hl
    push    bc
    push    de
    push    ix
    push    iy
    
    
    ld      hl,#0xe006 ; Kello laskemaan
    ld      a,#1
    ld      (hl),a
    xor     a
    ld      (hl),a        
    
    ld      a, (_kount)
    inc     a
    ld      (_kount), a
    
    ld      a, (_musa_tick)
    inc     a
    cp      #18
    jr      nz, 4$
    
    ; tick needs to be zeroed
    
    ld      a, (_musa_beat)
    inc     a
    cp      #4
    jr      nz, 5$
    
    ; eighth needs to be zeroed
    
    ld      a, (_musa_bar)
    inc     a
    ld      (_musa_bar), a
    
    xor     a
    
5$:
    ld      (_musa_beat), a

    xor     a
4$: 
    ld      (_musa_tick), a
    
    
    ld      hl,#0xe004
    ld      a, (_PLY_PSGRegistersArray)
    ld      b, a
    sla     a
    sla     a
    sla     a
    sla     a
    ld      (hl), a
    srl     b
    srl     b
    srl     b
    srl     b
    ld      a, (_PLY_PSGRegistersArray+1) 
    sla     a
    sla     a
    sla     a
    sla     a
    add     a, b
    ld      (hl), a
    
    call    _PLY_Play

    pop     iy
    pop     ix
    pop     de
    pop     bc
    pop     hl
    pop     af

    ei
    
    reti
    _endasm;
}

void shut_up()
{
    poke(0xe008, 0); // Sound off
    uninstall_isr();
}

void waitblank()
{
    unsigned char prevvi=kount;

    while(prevvi==kount)
        ;
}

main()
{
    int offi=0,n;

    mem_set((char *)COLOR_TABLE,0,40*25);
    mem_set((char *)CHAR_TABLE,0xd0,40*25);

    PLY_SongPtr = (char *)0x1203;
    PLY_Init();

    waitVB();

    // Music starts now
    install_isr(my_isr);
    
    DI;
    poke(0xe007,0xb0); // Counter 2 counts once
    poke(0xe006,1);
    poke(0xe006,0);

    poke(0xe007,0x74); // 100 Hz
    poke(0xe005,156 & 0xff);
    poke(0xe005,0);
    
    poke(0xe008, 1); // Sound on
    EI;

    for(n=0;n<5*32;n++) // Wait over intro
	waitblank();

    while(!space())
    {
        waitblank(); // Can't trust waitVB with music
        waitblank();
        waitblank();

        mem_cpy((char *)COLOR_TABLE,&anim[offi],40*25);

        offi+=40*25;
        if(offi==40*25*12)
            offi=0;
    }

    shut_up();
    download();
}
